REBOL []

install-module [
	name: 'rmc
	
	funcs-file: %rmc/functions.r
	
	exec: res: none
	
	
	reply: func [value /error][
		remold [either error ['error]['ok] value]
	]

	do load-exec: does [
		exec: context load/all funcs-file
	]
	
	extract-funcs: has [out name spec][
		out: make block! 2 * length? exec/publish
		foreach name exec/publish [
			either all [
				spec: in exec :name
				function? spec: get spec
			][
				spec: third :spec
				clear find spec /local
				repend out [name spec]
			][
				log/error ["function >" mold name "< not defined!"]
			]
		]
		out
	]
	
	on-task-received: func [data][
		response: switch/default first data [
			list [
			
			]
			import [
				either data/2 = 'all [
					reply extract-funcs
					
				][
					; import [func1 func2 ...]
				]
			]
			do [
				either find exec/publish data/2 [
					change at data 2 to-lit-word data/2
					insert remove data [do in exec]
					either error? set/any 'res try data [
						res: disarm res
						res/near: skip res/near 3
						reply/error res
					][
						reply res
					]
				][
					reply/error "RMC: Unknown function!"
				]
			]
			refresh [
				load-exec
				reply none
			]
		][reply/error "RMC: Invalid command!"]
	]
]