REBOL []

install-service [
	name: 'rmc-server
	port-id: 4000
	module: 'rmc
	verbose: 0
	
	add-head: func [value][head insert value debase/base to-hex length? value 16]
	
	on-received: func [data][
		 either client/user-data = 'head [
			if verbose > 0 [log/info join "new request: " to string! data]
			shared/do-task data self
			client/user-data: none
			stop-at: 4
		][
			client/user-data: 'head
			stop-at: to integer! data
		]
	]
	
	on-task-done: func [data][
		write-client add-head copy data
	]
	
	on-task-failed: func [error][
		write-client add-head remold ['error disarm make error! "RMC Server error"]
	]
	
	stop-at: 4
]